﻿Type=Activity
Version=2.02
FullScreen=False
IncludeTitle=True
@EndOfDesignText@
Sub Process_Globals
	
	
	Dim LocationInputMode As String

	Dim Timer1 As Timer

	Dim MapCenter As GeoPoint
	Dim TileSource As String
	Dim ZoomLevel As Int
	
	'	create some variables to save the MyLocationOverlay state
	Dim CompassEnabled, FollowLocationEnabled, MyLocationEnabled As Boolean
		
	Dim Geocoder1 As Geocoder

'----
		Dim FocusedMarker, Marker0, Marker1, Marker2, Marker3 As Marker
		'	we'll use the new BalloonMarker object for Marker4
		Dim Marker4 As BalloonMarker

		Dim mapMarker As Marker
		Dim mapBalloonMarker As BalloonMarker
		Dim lstMapMarkers As List
		lstMapMarkers.Initialize
		Dim lstMapBalloonMarkers As List
		

End Sub

Sub Globals

	Dim Label1 As Label
	Dim Label2 As Label


	Dim MapView1 As MapView
	Dim NewTileSourceName As String
	Dim TileSourceSpinner As Spinner
	
	Dim ScaleBarOverlay1 As ScaleBarOverlay
	Dim MyLocationOverlay1 As MyLocationOverlay

	Dim pnlCompass As Panel
	Dim pnlCrossHair As Panel

  Dim btnGetLocation As Button


	Dim pnlAddress As Panel

	Dim btnRight As Button
  Dim btnLeft As Button

	Dim gd1 As GradientDrawable
	Dim gd2 As GradientDrawable
	Dim cols1(2) As Int 
	Dim cols2(2) As Int 

	'	create the MinimapOverlay
'	Dim MinimapOverlay1 As MinimapOverlay

	Dim MarkersBalloonOverlay1 As MarkersBalloonOverlay

End Sub

Sub Activity_Create(FirstTime As Boolean)

	Activity.AddMenuItem("Fit Map to Markers", "FitMap")


	pnlAddress.Initialize("pnlAddress")
	Label1.Initialize("Lable1")
	Label2.Initialize("Lable2")

  Timer1.Initialize("Timer1", 10000) ' 10000 = 10 seconds

	'	update the MenuItems
'	Activity.AddMenuItem("Toggle Compass", "MenuItemSelect")
'	Activity.AddMenuItem("Toggle MyLocation", "MenuItemSelect")
'	Activity.AddMenuItem("Toggle FollowLocation", "MenuItemSelect")
	
	'	MapView initialized with no EventName as we'll not be listening for MapView events
	'MapView1.Initialize("")
	MapView1.Initialize("MapView1")
	
	MapView1.SetMultiTouchEnabled(True)
	MapView1.SetZoomEnabled(True)
	
	'	initialize and add the MyLocationOverlay to the MapView, an EventName is used as we'll be listening for all three events that this overlay generates
	MyLocationOverlay1.Initialize(MapView1, "MyLocationOverlay1")
	MapView1.AddOverlay(MyLocationOverlay1)
	
	MarkersBalloonOverlay1.Initialize( MapView1, "", "balloon_overlay")
	MapView1.AddOverlay(MarkersBalloonOverlay1)


	If FirstTime Then
	
	
		MapCenter.Initialize(-37.85, 145.06)
	
		TileSource="Google Maps"
		ZoomLevel=17

		Geocoder1.Initialize
		
		Dim OfflineTileCacheFilename, TileCacheDir As String
		OfflineTileCacheFilename="GLEN_IRIS_256.zip"
		'OfflineTileCacheFilename="melbourne_offline_tile_cache.zip"
		
		TileCacheDir=File.DirRootExternal &"/osmdroid"
		
		'	check if the offline tile cache 
		'has already been copied To the OSMDroid cache folder
		If File.Exists(TileCacheDir, OfflineTileCacheFilename)=False Then
			
			'	create the 'osmdroid' cache folder if it does not exist
			If File.Exists(TileCacheDir&"/", "")=False Then
				File.MakeDir(File.DirRootExternal, "osmdroid")
			End If
			
			'	copy the offline tile cache to the OSMDroid cache folder
			File.Copy(File.DirAssets, OfflineTileCacheFilename, TileCacheDir, OfflineTileCacheFilename)
		End If
		
		NewTileSourceName="Google Maps"
		'NewTileSourceName="OSM CloudMade 1"
		
		Dim CurrentTilesSources As List
		CurrentTilesSources=MapView1.GetTileSources
		If CurrentTilesSources.IndexOf(NewTileSourceName)=-1 Then
		'	the NewTileSourceName has not yet been added to the MapView
			Dim MyXYTileSource As XYTileSource
			
			                         '"Google Maps"        
			MyXYTileSource.initialize(NewTileSourceName, 0, 20, 256, ".png",  "http://localhost/")
			MapView1.AddXYTileSource(MyXYTileSource)
			
			'	note that after Activity_Pause (orientation change for example) 
			' the added XYTileSource will still exist in the MapView
			'	the added XYTileSorce will exist until the activity process is destroyed
			'	trying to add an XYTileSource more than once will not cause problems 
			' however - the AddXYTileSource method ensures that the tile source Is only added once
		End If
		
		'	set the default initial TileSource
		TileSource=NewTileSourceName
		
	
	'----
		
		Timer1.Enabled = False
		Timer1.Interval = 1000
		Timer1.Enabled = True

			'	add the List of Markers to the MarkersBalloonOverlay
			MarkersBalloonOverlay1.AddMarkers(lstMapMarkers)

	Else
	
		MyLocationOverlay1.CompassEnabled=True
		MyLocationOverlay1.MyLocationEnabled=True
		MyLocationOverlay1.FollowLocationEnabled=True
	
	End If
	
'	MinimapOverlay1.Initialize(MapView1)
'	
'	MinimapOverlay1.ZoomDifference = 4
'	MinimapOverlay1.Height=150
'	MinimapOverlay1.Padding=50
'	MinimapOverlay1.Width=150
	
	'	it is required that the MapView Invalidate method is called to force the MapView to update it's display
	MapView1.Invalidate



	MapView1.SetMultiTouchEnabled(True)
	MapView1.SetZoomEnabled(True)
	MapView1.Zoom=ZoomLevel
	MapView1.SetCenter3(MapCenter)
	
	ScaleBarOverlay1.Initialize(MapView1)
	MapView1.AddOverlay( ScaleBarOverlay1)
	
	TileSourceSpinner.Initialize("TileSourceSelect")
	Activity.AddView(TileSourceSpinner, 0, 0, 100%x, 48dip)
	
	TileSourceSpinner.AddAll(MapView1.GetTileSources)
	TileSourceSpinner.Prompt="Select a TileSource"
	TileSourceSpinner.SelectedIndex=TileSourceSpinner.IndexOf(TileSource)
	TileSourceSelect_ItemClick(TileSourceSpinner.SelectedIndex, TileSourceSpinner.SelectedItem)
	
	'Activity.AddView(MapView1, 0, 48dip, 100%x, 100%y-48dip)
	Activity.AddView(MapView1, 0, 0, 100%x, 100%y)

	pnlCompass.Initialize("pnlCompass")
	pnlCrossHair.Initialize("pnlCrossHair")

	'pnlCompass.Color = Colors.Transparent
	
	Activity.AddView(pnlCompass, 10dip, 60dip, 50dip,  50dip)
	Activity.AddView(pnlCrossHair, 50%x - 24dip, 50%y - 24dip, 48dip,  48dip)

	Dim bd As BitmapDrawable
	bd.Initialize(LoadBitmap(File.DirAssets, "gpscenter.png"))
	'bd.Gravity = Gravity.FILL
	pnlCrossHair.Background = bd
	pnlCrossHair.Visible = False

	
	btnGetLocation.Initialize("btnGetLocation")
	
  Dim bd2 As BitmapDrawable
	bd2.Initialize(LoadBitmap(File.DirAssets, "gpscenter.png"))
	'bd.Gravity = Gravity.FILL
	btnGetLocation.Background = bd2
		
	
	Activity.AddView( btnGetLocation, 100%x - 80, 10dip, 50dip,  50dip)
	btnGetLocation.Text = "Get"

	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	cols1(0) = Colors.argb ( 120, 136, 136, 136)
	cols1(1) = Colors.argb ( 120, 0, 0, 0)
	
	gd1.Initialize("TOP_BOTTOM",cols1)
	gd1.CornerRadius=5

 
	Activity.AddView(pnlAddress, 60dip, 50%y - 80dip,  200dip, 40dip)

	btnLeft.Initialize("btnLeft")
	Activity.AddView(btnLeft, 5, pnlAddress.top, 50dip, 40dip)
	btnLeft.Text = "Get"
	
	
	btnRight.Initialize("btnRight")
	btnRight.Text = "Set"
	Activity.AddView(btnRight, 100%x - 80, pnlAddress.top,  50dip, 40dip)
	
	pnlAddress.Background=gd1

	
	Dim TimeNewRomanBold As Typeface
	TimeNewRomanBold = Typeface.LoadFromAssets("Times.ttf")
	TimeNewRomanBold = Typeface.CreateNew(TimeNewRomanBold, Typeface.STYLE_BOLD)

	Label1.textsize = Label1.TextSize -3
	Label1.Text = "Selected address:"
	Label1.Gravity = Gravity.CENTER
	Label1.TextColor = Colors.argb ( 255, 255, 255, 255)

	Activity.AddView(Label1, pnlAddress.Left, pnlAddress.top,  pnlAddress.Width, pnlAddress.Height - 30)
	
	Label2.textsize = Label2.TextSize + 5
	'Label2.Typeface = TimeNewRomanBold
	Label2.Text = "55a Iris Rd"
	Label2.Gravity = Gravity.CENTER
	Label2.TextColor = Colors.argb ( 255, 255, 255, 255)

	Activity.AddView(Label2, pnlAddress.Left, pnlAddress.top + 20,  pnlAddress.Width, pnlAddress.Height - 15)

	'btnLeft.Color = Colors.Transparent
	btnLeft.TextColor = Colors.White
	
	'btnRight.Color = Colors.Transparent
	btnRight.TextColor = Colors.White
	
	Dim colorsEnabled(2) As Int

	colorsEnabled(0) = Colors.argb ( 120, 136, 136, 136)
	colorsEnabled(1) = Colors.argb ( 120, 0, 0, 0)
	

	' Define a GradientDrawable for Enabled state
	Dim gradDrawEnabled As GradientDrawable
	gradDrawEnabled.Initialize("TOP_BOTTOM",colorsEnabled)
	gradDrawEnabled.CornerRadius = 5




	' Define two gradient colors for Pressed state
	Dim colorsPressed(2) As Int
	colorsPressed(1) = Colors.aRGB(120, 136, 136, 136)
	colorsPressed(0) = Colors.aRGB(120, 0, 0, 0)
	
	' Define a GradientDrawable for Pressed state
	Dim gradDrawPressed As GradientDrawable
	gradDrawPressed.Initialize("TOP_BOTTOM",colorsPressed)
	gradDrawPressed.CornerRadius = 5



	' Define a StateListDrawable
	Dim stdGradient As StateListDrawable
	stdGradient.Initialize
	
	Dim states(2) As Int
	states(0) = stdGradient.state_enabled
	states(1) = -stdGradient.state_pressed
	stdGradient.addState2(states, gradDrawEnabled)

	Dim states(1) As Int
	states(0) = stdGradient.state_pressed
	stdGradient.addState2(states, gradDrawPressed)
	
	' Set stdRedGradient to button background
	btnRight.Background = stdGradient

	
	
	' Define a StateListDrawable
	Dim stdGradient2 As StateListDrawable
	stdGradient2.Initialize
	
	Dim states(2) As Int
	states(0) = stdGradient2.state_enabled
	states(1) = -stdGradient2.state_pressed
	stdGradient2.addState2(states, gradDrawEnabled)

	Dim states(1) As Int
	states(0) = stdGradient2.state_pressed
	stdGradient2.addState2(states, gradDrawPressed)
	
	' Set stdRedGradient to button background
	btnLeft.Background = stdGradient2



	Label1.Text = "Move Map or Press Get  to Retrieve Address"
	Label2.Text = ""
	
  btnLeft.Visible = False
  Label1.Visible = False
	Label2.Visible = False
	pnlAddress.Visible = False
	
  btnRight.Visible = False


	'	initialize the MinimapOverlay and add it to the MapView
	'	** IMPORTANT a MinimapOverlay must be the LAST overlay layer to be added to a MapView otherwise other overlay layers may not display correctly **
	'	This may be fixed with future versions of the native Android OSMDroid library.
	'MapView1.AddOverlay(MinimapOverlay1)
	
	'Activity.AddMenuItem("Do something", "DoSomething")




'  Dim argb() As Int
'  
'	argb = GetARGB(Colors.White)
'  
'	Log("White A = " & argb(0))
'  Log("White R = " & argb(1))
'  Log("White G = " & argb(2))
'  Log("White B = " & argb(3))

	'SetNinePatchDrawable(pnlAddress, "pnlAddress")
	
	
	
	
	
	
			Dim icon As BitmapDrawable
  	'icon.Initialize(LoadBitmap(File.DirAssets, "coles_express_poi.bmp"))
		icon.Initialize(LoadBitmap(File.DirAssets, "gmap_marker_default.gif"))
		

		If Main.lstMarkers.Size > 0 Then 
			For I = 0 To Main.lstMarkers.Size -1 
			 	Dim m As typMarker
				m.Initialize
				m = Main.lstMarkers.get(I)
				Log(m)

				mapMarker.Initialize("Coles Express",m.Name,m.Lat,m.lng,icon)
				lstMapMarkers.Add(mapMarker)

			Next
			
			'	add the List of Markers to the MarkersBalloonOverlay
			MarkersBalloonOverlay1.AddMarkers(lstMapMarkers)
			MapView1.FitMapToBoundingBox(MarkersBalloonOverlay1.GetBoundingBox)
		End If

	
	
	
	
	
	
	

End Sub

Sub Activity_Resume
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	
	FocusedMarker=MarkersBalloonOverlay1.FocusedMarker

	MapCenter=MapView1.GetCenter
	TileSource=MapView1.GetTileSource
	ZoomLevel=MapView1.Zoom
	
	'	save the MyLocationOverlay state
	CompassEnabled=MyLocationOverlay1.CompassEnabled
	FollowLocationEnabled=MyLocationOverlay1.FollowLocationEnabled
	MyLocationEnabled=MyLocationOverlay1.MyLocationEnabled
	
	'	disable MyLocationOverlay compass and GPS listening
	MyLocationOverlay1.CompassEnabled=False
	MyLocationOverlay1.MyLocationEnabled=False
	
End Sub


Sub FitMap_Click
	MapView1.FitMapToBoundingBox(MarkersBalloonOverlay1.GetBoundingBox)
End Sub




'	event listeners for the three events that MyLocationOverlay generates

Sub MyLocationOverlay1_FollowLocationAutoDisabled

	Log("MyLocationOverlay1_FollowLocationAutoDisabled")
	'	if FollowLocation is enabled and the map is dragged then FollowLocation is automatically disabled

	
'	If pnlAddress.Visible = True Then
'		MyLocationOverlay1.CompassEnabled=False
'		MyLocationOverlay1.MyLocationEnabled=False
'		MyLocationOverlay1.FollowLocationEnabled=False
'		Timer1.Enabled = False
'		Timer1.Interval = 1000
'		Timer1.Enabled = True
'   Else
'		MyLocationOverlay1.CompassEnabled=True
'		MyLocationOverlay1.MyLocationEnabled=True
'		MyLocationOverlay1.FollowLocationEnabled=True
			Timer1.Enabled = False
			Timer1.Interval = 10000
			Timer1.Enabled = True
'	End If
'	

End Sub

Sub MyLocationOverlay1_LocationChanged(NewLocation As Location, IsFirstFix As Boolean)
	
	'I think this fires if tracking is on AND gps location changes
	
	'Log("MyLocationOverlay1_LocationChanged, Latitude="&NewLocation.Latitude&", Longitude="&NewLocation.Longitude&", IsFirstFix="&IsFirstFix)
	'	ToastMessageShow("ZoomLevel = " & MapView1.Zoom, False) ' true=3 sec , false=2 sec
'	If MapView1.Zoom = 19 Then
'    MapView1.Zoom = 18
'	End If

'	If pnlAddress.Visible = True Then
''	   Timer1.Enabled = False
'		btnLeft.Visible = True
'		btnRight.Visible = False
'	End If
	

End Sub

Sub MyLocationOverlay1_ProviderChanged(Provider As String, Enabled As Boolean)
	'	note that i have yet to see this event generated
	'Log("MyLocationOverlay1_ProviderChanged, Provider="&Provider&", Enabled="&Enabled)
End Sub

Sub TileSourceSelect_ItemClick (Position As Int, Value As Object)
	MapView1.SetTileSource(Value)
	
	'	set the MinimapOverlay TileSource to match the main MapView map TileSource
	'MinimapOverlay1.SetTileSource(Value)
End Sub
Sub MapView1_CenterChanged
   ' Log("MapView1_CenterChanged")
    '    keep the SimpleLocationOverlay centered on the map center
    '    MapView.Invalidate is not called here as the MapView will (internally) invalidate itself when it's center changes
    'SimpleLocationOverlay1.SetMyLocation3(MapView1.GetCenter)
End Sub


'    listen for the MapView ZoomChanged event
Sub MapView1_ZoomChanged 
    Log("MapView1_ZoomChanged ZoomLevel=  " & MapView1.Zoom)
End Sub

Sub Timer1_Tick

	'Handle tick events
	MyLocationOverlay1.CompassEnabled=True
	MyLocationOverlay1.MyLocationEnabled=True
	MyLocationOverlay1.FollowLocationEnabled=True
	
	Timer1.Enabled = False
		
End Sub

Sub btnRecentre_Click

	MyLocationOverlay1.CompassEnabled=True
	MyLocationOverlay1.MyLocationEnabled=True
	MyLocationOverlay1.FollowLocationEnabled=True

End Sub

Sub pnlCompass_Click

	MyLocationOverlay1.CompassEnabled=True
	MyLocationOverlay1.MyLocationEnabled=True
	MyLocationOverlay1.FollowLocationEnabled=True
	
	Timer1.Enabled = False

	
'	Return True

End Sub

Sub btnGetLocation_Click

	Timer1.Enabled = False

	If btnGetLocation.Text = "Get" Then
		MyLocationOverlay1.CompassEnabled=False
		MyLocationOverlay1.MyLocationEnabled=False
		MyLocationOverlay1.FollowLocationEnabled=False
		'btnGetLocation.Text = "Set"
		pnlCrossHair.Visible = True
		btnGetLocation.Visible = False
		GetLocationSetup

		btnLeft.Visible = True
		pnlAddress.Visible = True
	  Label1.Visible = True
	  Label2.Visible = True
		btnRight.Visible = False
		Label1.Text = "Move Map or Press Get  to Retrieve Address"
		Label2.Text = ""
		
'	Else 'btnGetLocation.Text = "Set"
'	
'	  MapCenter=MapView1.GetCenter
'
'		Dim Results() As Address
'		Results=Geocoder1.GetFromLocation(MapCenter.Latitude, MapCenter.Longitude, 5)
'		
'		Dim fullAddress As String
'		
'		If Results.Length > 0 Then
'			Log("Results:" & Results)
'			Dim Address1 As Address
'			
'			Address1 = Results(0) 'First line of results is usualla an exact address
'			'Address1: 0: (Address) Address[addressLines=[0:"55 Iris Rd",1:"Glen Iris VIC 3146",2:"Australia"],
'			'feature=55,admin=Victoria,Sub-admin=Null,locality=Glen Iris,thoroughfare=Iris Rd,postalCode=3146,countryCode=AU,countryName=Australia,
'			'hasLatitude=True,Latitude=-37.850928,hasLongitude=True,Longitude=145.057488,phone=Null,url=Null,extras=Null]
'			
'			fullAddress = Address1.AddressLines.Get(0) & CRLF & Address1.AddressLines.Get(1) '& CRLF & Address1.CountryCode
'				
'			Msgbox(fullAddress, "Address matching Selected Location:")
'		
'		Else
'			Msgbox("GetFromLocation", "No Address matching Selected Location")
'		End If
'
'		MyLocationOverlay1.CompassEnabled=True
'		MyLocationOverlay1.MyLocationEnabled=True
'		MyLocationOverlay1.FollowLocationEnabled=True
'		btnGetLocation.Text = "Get"
'		pnlCrossHair.Visible = False
'		
	End If


'	

End Sub

Sub GetLocationSetup

End Sub

Sub btnLeft_click
	
    If btnLeft.Text = "Get" Then


		  Dim strTemp As String
			
			strTemp = Label2.Text
			Label2.Text = "Searching for address ..."

			

			MyLocationOverlay1.CompassEnabled=False
			MyLocationOverlay1.MyLocationEnabled=False
			MyLocationOverlay1.FollowLocationEnabled=False

		  MapCenter=MapView1.GetCenter

			Dim Results() As Address
			Results=Geocoder1.GetFromLocation(MapCenter.Latitude, MapCenter.Longitude, 5)
			
			Dim fullAddress As String
			
			If Results.Length > 0 Then
				Log("Results:" & Results)
				Dim Address1 As Address
				
				Address1 = Results(0) 'First line of results is usualla an exact address
				'Address1: 0: (Address) Address[addressLines=[0:"55 Iris Rd",1:"Glen Iris VIC 3146",2:"Australia"],
				'feature=55,admin=Victoria,Sub-admin=Null,locality=Glen Iris,thoroughfare=Iris Rd,postalCode=3146,countryCode=AU,countryName=Australia,
				'hasLatitude=True,Latitude=-37.850928,hasLongitude=True,Longitude=145.057488,phone=Null,url=Null,extras=Null]
				
				fullAddress = Address1.AddressLines.Get(0) & CRLF & Address1.AddressLines.Get(1) '& CRLF & Address1.CountryCode
				
				Label2.Text = fullAddress
					
				'Msgbox(fullAddress, "Address matching Selected Location:")
				
				Label1.Text = "Move Map or Press Set to Select Address"
			  btnRight.Visible = True
'			  btnLeft.Visible = False
				
			Else
				Msgbox("Get Address from Location", "No Address matching Selected Location")
			End If
		
		End If

End Sub

Sub btnRight_Click

 If btnRight.Text = "Set" Then
		
		Label1.Text = "Selected Address:"
		btnLeft.Text = "List"
		btnRight.Text = "Use"
		
		'btnLeft.Visible = False
		'btnRight.Visible = False
		pnlCrossHair.Visible = False
		'btnGetLocation.Text = "Set"
		btnGetLocation.Visible = True

		Timer1.Enabled = False
		Timer1.Interval = 1000
		Timer1.Enabled = True

 End If

End Sub

Sub DoSomething_Click
	'	change some MinimapOverlay defaults
'	MinimapOverlay1.Height=300
'	MinimapOverlay1.Padding=50
'	MinimapOverlay1.Width=300
	'	it is required that the MapView Invalidate method is called to force the MapView to update it's display
	MapView1.Invalidate
End Sub